<script lang="ts">
import Vue from 'vue';
import { SolutionsVideoModal } from '../../solutions/index.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

interface Video {
  title: string;
  internalName: string;
  thumbnail: string;
  url: string;
}

interface Group {
  header: string;
  description: string;
  card: Card[];
}

interface Card {
  iconName: string;
  title: string;
  description: string;
  long?: boolean;
}

interface Section {
  video: Video;
  group: Group;
}

export default Vue.extend({
  components: {
    SolutionsVideoModal,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    header: {
      type: String,
      required: true,
    },
    text: {
      type: String,
      required: true,
    },
    sections: {
      type: Array<Section>,
      required: true,
    },
  },
  data() {
    return {
      showModal: false,
      showModalTwo: false,
    };
  },
  methods: {
    openModal() {
      this.showModal = true;
    },
    openModalTwo() {
      this.showModalTwo = true;
    },
  },
});
</script>

<template>
  <div class="features-alt">
    <div>
      <SlpTypography
        :data-aos="'fade-up'"
        :data-aos-duration="1200"
        :data-aos-offset="200"
        class="slp-pb-16 text-white"
        variant="heading2-bold"
        tag="h2"
      >
        {{ header }}
      </SlpTypography>
      <div
        :data-aos="'fade-up'"
        :data-aos-duration="1200"
        :data-aos-offset="200"
        class="text-heading text-gray slp-mb-96"
        v-html="$md.render(text)"
      />
    </div>
    <div>
      <div class="ai-features-card">
        <div class="ai-features-card__inner" @click="openModal()">
          <SlpIcon
            class="play-icon"
            name="play-circle"
            variant="marketing"
            size="xl"
          />
          <img :src="sections[0].video.thumbnail" />
        </div>
        <SolutionsVideoModal
          v-show="showModal && sections[0].video.url"
          light-background
          :visible="showModal"
          @close="showModal = false"
        >
          <template #body>
            <lite-vimeo
              :videoid="
                getVimeoVideoId(createVideoSource(sections[0].video.url))
              "
              autoplay
            ></lite-vimeo>
          </template>
        </SolutionsVideoModal>
        <div class="ai-card-content">
          <SlpTypography
            class="slp-pb-16"
            variant="heading2-bold"
            tag="h2"
            :data-aos="'fade-up'"
            :data-aos-duration="1200"
            :data-aos-offset="200"
          >
            {{ sections[0].group.header }}
            <nuxt-img
              style="position: relative; top: -20px"
              src="/nuxt-images/solutions/ai/icons/eyebrow-one.svg"
              alt=""
              format="webp"
              quality="99"
            />
          </SlpTypography>
          <div
            class="text-gray slp-mb-48 text-subheading"
            :data-aos="'fade-up'"
            :data-aos-duration="1200"
            :data-aos-offset="200"
            v-html="$md.render(sections[0].group.description)"
          />
          <div class="ai-features-card-list chat">
            <div
              v-for="(item, index) in sections[0].group.card"
              :key="index"
              class="ai-features-card-item chat"
              :data-aos="'fade-up'"
              :data-aos-duration="1200"
              :data-aos-offset="200"
            >
              <SlpIcon
                :name="item.iconName"
                color="white"
                variant="marketing"
                size="md"
              />
              <SlpTypography variant="body1-bold" class="slp-mt-8" tag="h4">{{
                item.title
              }}</SlpTypography>
              <SlpTypography class="text-gray" variant="body2" tag="p">{{
                item.description
              }}</SlpTypography>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="slp-mt-96">
      <div class="ai-features-card">
        <div class="ai-features-card__inner" @click="openModalTwo()">
          <SlpIcon
            class="play-icon"
            name="play-circle"
            variant="marketing"
            size="xl"
          />
          <img :src="sections[1].video.thumbnail" />
        </div>
        <SolutionsVideoModal
          v-show="showModalTwo && sections[1].video.url"
          light-background
          :visible="showModalTwo"
          @close="showModalTwo = false"
        >
          <template #body>
            <lite-vimeo
              :videoid="
                getVimeoVideoId(createVideoSource(sections[1].video.url))
              "
              autoplay
            ></lite-vimeo>
          </template>
        </SolutionsVideoModal>
        <div class="ai-card-content">
          <SlpTypography
            class="slp-pb-16"
            variant="heading2-bold"
            tag="h2"
            :data-aos="'fade-up'"
            :data-aos-duration="1200"
            :data-aos-offset="200"
          >
            {{ sections[1].group.header }}
            <nuxt-img
              style="position: relative; top: -20px"
              src="/nuxt-images/solutions/ai/icons/eyebrow-one.svg"
              alt=""
              format="webp"
              quality="99"
            />
          </SlpTypography>
          <div
            class="text-gray slp-mb-48 text-subheading"
            :data-aos="'fade-up'"
            :data-aos-offset="200"
            :data-aos-duration="1200"
            v-html="$md.render(sections[1].group.description)"
          />
          <div class="ai-features-card-list">
            <div
              v-for="(item, index) in sections[1].group.card"
              :key="index"
              class="ai-features-card-item"
              :class="{ 'ai-features-card-item--long': item.long }"
              :data-aos="'fade-up'"
              :data-aos-duration="1200"
              :data-aos-offset="200"
            >
              <SlpIcon
                :name="item.iconName"
                color="white"
                variant="marketing"
                size="md"
              />
              <SlpTypography variant="body1-bold" class="slp-mt-8" tag="h4">{{
                item.title
              }}</SlpTypography>
              <SlpTypography class="text-gray" variant="body2" tag="p">{{
                item.description
              }}</SlpTypography>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.features-alt {
  color: white;

  &::v-deep strong {
    font-weight: 600;
    color: white;
  }
}

.ai-features-card {
  border: 1px solid #45424d;
  border-radius: 12px;
  overflow: hidden;

  &__inner {
    position: relative;
    margin-bottom: -6px;

    img {
      width: 100%;
      cursor: pointer;
      display: block;
      transition: all 0.2s ease;
    }

    &:hover {
      img {
        filter: brightness(0.8);
      }
      .play-icon::v-deep {
        circle {
          fill: #171321;
        }
        path {
          fill: white;
        }
      }
    }

    .play-icon {
      position: absolute;
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%);
      font-size: 48px;
      color: #fff;
      cursor: pointer;
      z-index: 2;

      ::v-deep path {
        fill: black;
        transition: fill 0.2s ease;
      }

      ::v-deep circle {
        transition: fill 0.2s ease;
      }
    }
  }
}

.ai-card-content {
  padding: 32px;
  background: linear-gradient(
    0.71deg,
    rgba(225, 152, 109, 0.1) 0.61%,
    rgba(110, 67, 211, 0.1) 99.4%
  );

  &::v-deep em {
    font-style: normal;
    color: white;
  }
}

.ai-features-card-list {
  display: flex;
  flex-wrap: wrap;
  gap: 24px;

  &.chat {
    display: grid;
    grid-template-columns: 1fr 1fr;
    grid-template-rows: 1fr 1fr;
    justify-items: stretch;
    align-items: stretch;
  }

  @media screen and (max-width: 768px) {
    flex-direction: column;

    &.chat {
      grid-template-columns: 1fr;
    }
  }
}

.ai-features-card-item {
  border-radius: 8px;
  width: calc(50% - 12px);
  padding: 24px;
  background: #171321;

  &.chat {
    width: initial;
  }

  @media screen and (max-width: 768px) {
    width: 100%;
  }

  &--long {
    width: 100%;
  }
}

.text-heading {
  font-size: 32px;
  font-weight: 600;
  letter-spacing: -0.8px;
  line-height: 40px;
}

.text-subheading {
  font-size: 24px;
  font-weight: 600;
  letter-spacing: -0.6px;
  line-height: 32px;
}

.text-gray {
  color: #a2a1a6;
}

.text-white {
  color: white;
}

/* copy pasted from featured-add-ons-card-tier.vue, but with some adjustments */
.addon-tier__pill-wrapper {
  top: -30px;
  position: relative;
  padding: 4px 12px;
  display: inline-block;

  &::before {
    content: '';
    position: absolute;
    inset: 0;
    border-radius: 20px;
    border: 1.5px solid transparent;
    background: linear-gradient(
        89.09deg,
        #e1986d -1.12%,
        #7759c2 102.06%,
        #6e43d3 102.07%
      )
      border-box;
    -webkit-mask:
      linear-gradient(#fff 0 0) padding-box,
      linear-gradient(#fff 0 0);
    -webkit-mask-composite: xor;
    mask-composite: exclude;
  }
}

.addon-tier__pill {
  img {
    position: absolute;
    top: 8px;
  }

  span {
    padding-left: 20px;
    display: block;
    letter-spacing: 0.3px;
  }
}
</style>
